    function FSP_Algorithm(fh,dum1)
        disp(' ')
        disp('The code will use a previous FSP solution to define the next polynomial projection,')
        disp('and then solve for the next projection.')
        disp('When a sufficient projection is found, the distribution will be plotted in Figure 2,')
        disp('and the chosen projection space will be plotted in Figure 3.')
     
        handles = guidata(1);
        handles.err = inf;
        while handles.err>handles.Epsilon
            if ~isempty(handles.Bounds)
                for i=1:length(handles.N_max)
                    if handles.Bounds(i)>=handles.Epsilon/length(handles.N_max)
                        handles.N_max(i) = handles.N_max(i)+max(1,ceil(max(abs(handles.N_max(i))*0.25)));
                    end
                end
            else
                if isempty(handles.SSA_XY_Counts)
                    SSA_Callback(fh);
                    handles = guidata(1);
                end
                %                 handles.N_max =max(0,max(Projection_Shape_Functions(handles.SSA_XY_Counts(:,1),handles.SSA_XY_Counts(:,2))));
                handles.N_max =max(Projection_Shape_Functions(handles.SSA_XY_Counts(:,1),handles.SSA_XY_Counts(:,2)));
            end
            handles.Xmax1 = handles.N_max(3);
            handles.Xmax2 = handles.N_max(4);
            guidata(1,handles);
            Solve_Callback(fh);
            handles = guidata(fh);
%             Plot_FSP_Solns
        end
         Plot_FSP_Solns
    end
